<?php
/* $Id: dbfm_properties.inc,v 1.1.2.21 2008/06/11 16:09:56 geoffeagles Exp $ */

define ('DBFM_DIRECTORY', 1);
define ('DBFM_VERSION', 2);
define ('DBFM_OTHER', 3);         //files

function dbfm_propertit($fid) {
  global $base_url;
  $err = '';
  $ieflag = FALSE;

  //michals global gfid ZZZ - wassit for - why global? - aha I see why, he couldn't easily pass the fid to the properties form
  //well - if we're passing anything we're better off passing the whole file record in a global so gfrec is born
  global $gfrec;
  
  //we need to check the user's permission - if the user only has read access here then we'll need to add an extra button to the form
  if (($gfrec = dbfm_selected_file_record($fid,'', $err)) == FALSE) {
    //can't open the file record so error
    $extra = '<p>Unable to open file record - ' . $err . '</p>';
    $output = dbfm_popconstructor2('dbFM Properties Window', '', $extra);
    echo $output;
    exit();
  }
  $writeable = dbfm_check_perm($gfrec, READ_WRITE);

  $retval = dbfm_greybox_js($base_url);     //this should poke the path for greybox into the javascript header

  $modulepath = drupal_get_path('module', 'dbfm');
  $tabpath = drupal_get_path('module', 'tabs');
  $toolpath = drupal_get_path('module', 'jstools');

  $tabjs1 = $base_url . '/' . $tabpath .'/tabs.js';
  $tabjs2 = $base_url . '/' . $tabpath .'/jquery.tabs.pack.js';
  $tabjs3 = $base_url . '/' . $toolpath .'/jquery.history.pack.js';
  $stylepath = $base_url . '/' . $modulepath .'/css/upjava.css';
  if(strstr($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
    //conditional code for IE
    $tabstyle2 = $base_url . '/' . $tabpath .'/tabs-ie.css';
    $ieflag = TRUE;
  }
  $tabstyle1 = $base_url . '/' . $modulepath .'/css/dbfm_tabs.css';
  $tabstyle3 = $base_url . '/' . $tabpath .'/drupal-tabs.css';
  $jsjq = $base_url . '/' . 'misc/jquery.js';
  $jsdrup = $base_url . '/' . 'misc/drupal.js';

  $propertiesform = drupal_get_form('dbfm_form_properties');

  $output  = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN">'."\n";
  $output .= "<html>\n";
  $output .= "<head>\n";
  $output .= "<title>dbFM File Properties</title>\n";
  $output .= "<script type=\"text/javascript\" src=\"$jsdrup\"></script>\n";
  $output .= "<script type=\"text/javascript\" src=\"$jsjq\"></script>\n";
  $output .= "<script type=\"text/javascript\" src=\"$tabjs1\"></script>\n";
  $output .= "<script type=\"text/javascript\" src=\"$tabjs2\"></script>\n";
  $output .= "<script type=\"text/javascript\" src=\"$tabjs3\"></script>\n";
  
  $output .= "<script><!-- \n";
  //this runs when the page has finished loading - may get over the IE onload problem
  $output .= "$(document).ready(function() {\n";
  //test how the radio buttons are set and hide or show the groups and role selectors
  //this doesn't work, I presume because the controls are hidden / not accessable during form load
// $output .= "alert('Read write is ' +  $('#radiorw').val());";

  //I KNOW this is hideous - when I've time I'll make a new JQuery function to deal with this
  $output .= "$('input:radio:checked').each(function(n) {\n";
  $output .= "if (this.name == 'fwaccess') {\n";
  $output .= "if (this.value == 2) {\n";
  $output .= "$('#rwaclrole').show();\n";
  $output .= "$('#rwaclgroup').show();\n";
  $output .= "} else {\n";
  $output .= "$('#rwaclrole').hide()\n";
  $output .= "$('#rwaclgroup').hide()\n";
  $output .= "}}\n";
  $output .= "if (this.name == 'fraccess') {\n";
  $output .= "if (this.value == 2) {\n";
  $output .= "$('#roaclrole').show()\n";
  $output .= "$('#roaclgroup').show()\n";
  $output .= "} else {\n";
  $output .= "$('#roaclrole').hide()\n";
  $output .= "$('#roaclgroup').hide()\n";
  $output .= "}}});\n";
  
  if ($writeable) {
    //utterly crappy IE runs the onload code BEFORE finishing the screen. I have to put a small delay in otherwise I can't set focus
    $output .= "setTimeout(\"document.getElementById('edit-fname').focus()\",100); \n";  //add javascript to take focus
  }

  $output .= "document.onkeypress=function(e){\n";
    $output .= "var e = window.event || e;\n";
    $output .= "if (e.keyCode == 27 || e.which == 27){\n";
    $output .= "parent.dbFM.popUp = true;\n";   //try to fill a variable to prevent a directory fetch
  $output .= "parent.GB_hide();}}\n";


  $output .= "$('form :input').change(function() {\n";
//  $output .= "alert('name is -' + this.name + '- type is -' + this.type + '- value is -' + this.value);\n";
  $output .= "if (this.name == 'fwaccess') {\n";
  //if it's the radio button that's just been pressed we need to work out whether they've selected custom
  //and hide or show the selection area's
  $output .= "if (this.value == 2) {\n";
  //hide the prompt for versions / overwrite
  $output .= "$('#rwaclrole').show()\n";
  $output .= "$('#rwaclgroup').show()\n";
  $output .= "} else {\n";
  $output .= "$('#rwaclrole').hide()\n";
  $output .= "$('#rwaclgroup').hide()\n";
  $output .= "}}\n";
  
  $output .= "if (this.name == 'fraccess') {\n";
  //if it's the radio button that's just been pressed we need to work out whether they've selected custom
  //and hide or show the selection area's
  $output .= "if (this.value == 2) {\n";
  //hide the prompt for versions / overwrite
  $output .= "$('#roaclrole').show()\n";
  $output .= "$('#roaclgroup').show()\n";
  $output .= "} else {\n";
  $output .= "$('#roaclrole').hide()\n";
  $output .= "$('#roaclgroup').hide()\n";
  $output .= "}}\n";
  $output .= "});});\n";           //end of form change function and document onload

 
//  $output .= "});\n";           //end of form change function and document onload
  
  $output .= "// -->\n";
  $output .= "</script>\n";
 
  $output .= "<link href=\"$tabstyle1\" rel=\"stylesheet\" type=\"text/css\">";
  if ($ieflag) {
    $output .= "<link href=\"$tabstyle2\" rel=\"stylesheet\" type=\"text/css\">";
  }
  $output .= "<link href=\"$tabstyle3\" rel=\"stylesheet\" type=\"text/css\">";
  $output .= "<link href=\"$stylepath\" rel=\"stylesheet\" type=\"text/css\">";
  $output .= "</head>\n\n";
  //now put onload code entirely in JS
//  $output .= "<body onload='initpage()'>\n";
  $output .= "<body>\n";

  //insert the drupal form
  $output .= "<div class=\"propertiesleft\"></div>";
  $output .= "<div class=\"propertiesright\"></div>";
  $output .= "<div class=\"propertiesform\">";
  //ideally the best place to tell the greybox code whether or not it needs to refresh would be here...
  //unfortunately I couldn't make it happen so when I first call greybox I'm passing a value
  $output .= $propertiesform."</div>";
  //if the form is in read-only mode there's nothing to take the focus so I'm adding a button
  if ($writeable == false) {
    //put a close button which has the added bonus of being able to take the focus
    $output .= "<input type='button' id='focusit' value='Close' onclick='parent.GB_hide()'/>\n";
    $output .= "<script language='JavaScript'> document.getElementById('focusit').focus(); </script>\n";  //add javascript to take focus
  } 
  $output .= "</body>";
  $output .= "</html>\n";
  print $output;

}


function dbfm_form_properties_submit($form_id, $form_values) {
  global $base_url;
  $err = '';  //used to hold any errors

  $modulepath = drupal_get_path('module', 'dbfm');
  $stylepath = $base_url . '/' . $modulepath .'/css/dbfm.css';
  $jsjq = $base_url . '/' . 'misc/jquery.js';

  $updateerror = false;
  
  $fid = $form_values['fid'];
  //drag back the existing file record
  if (($orig_rec = dbfm_selected_file_record($fid, '', $err)) == FALSE) {
    $updatemessage = "ERROR: Unable to read file record for " . $form_values['fname'] . ". File may have been deleted";
    $updateerror = true;
  } 

   //check whether the filename has changed since the previous save, 
  $dirname_changed = false;
  if ($updateerror == false) {
    if ($orig_rec->fname != $form_values['fname']) {
      //the while loop is a substitute for a goto - we want all errors to skip to the end!
      while (1) {
        //ok, so they've changed the name - is the new name valid (we can always add extra tests later)
        $pat1 = '/[\/\*"\[\]\$<>\\\{\}';
        $pat2 = "'\+\?;:\|=@~#^&%]/";
        $pattern = $pat1 . $pat2;
        $pret = preg_match($pattern, $form_values['fname']);
        if ($pret == 1) {
          $updatemessage = "Invalid characters in file/directory name";
          $updateerror = true;
          break;
        }

        //ZZZZZZdoes the file have a valid extension - check is complicated by different extension lists for the different roles?
        //so I'm leaving it for a rainy day 
        $theLength = strlen(trim($form_values['fname']));
        if ($orig_rec->fmime == 'directory') {
          if ($theLength < 3) {
            $updatemessage = "Directory name is too short";
            $updateerror = true;
          }
          else if ($theLength > 40) {
            $updatemessage = "Directory name is too long (40 chars max)";
            $updateerror = true; 
		  }           
        }
        else {
           if ($theLength < 3) {
             $updatemessage = "Filename is too short";
             $updateerror = true;  
	       }          
          else if ($theLength > 45) {
            $updatemessage = "Filename name is too long (45 chars max)";
            $updateerror = true; 
		  }           
        }
        if ($updateerror == true) 
          break;  //leave the while loop

        //has the new name already been used - search through all the children of the parent directory for a duplicate
        //we HAVE to do this - no way to sneakily get into a versions directory here!!
        $qkids = "SELECT fid FROM {dbfm_file} WHERE fid = " . $orig_rec->fparent . " AND fname = '" . $form_values['fname'] . "'";
        $kidrecs = db_query($qkids);
        $numrecs = db_num_rows($kidrecs);
        if ($numrecs > 0) {
          $updatemessage = 'Rename not allowed - A file of that name already exists';
          $updateerror = true; 
          break;
        }

        //they've altered the file or directory name so we may need to reform the path
        //take the path for the parent directory and append the filename
        $pathdata = $orig_rec->fpath;
        $position = (strrpos($pathdata, '/',1));  //finds the position, in the original record, of the last slash
        if ($position == 'false') {
          $updatemessage = 'Path data error. Contact your administrator.';
          $updateerror = true;
          break;
        }

        $tempstring = (substr ($pathdata, 0, $position));  //returns path minus file/diectory name
        if ($orig_rec->fmime == 'directory') {
          if ($orig_rec->ftitle == '') {
            $form_values['ftitle'] = $orig_rec->fname;
          }
          else {
            $form_values['ftitle'] = $orig_rec->ftitle;
          }

          if ($orig_rec->fsize > 0) {
            //we're going to need a recursive change to the children of this directory - set a flag
            $dirname_changed = true;
          }
        }

        // load metadata variables ready for dbfm_update - added access data
        $metadata=array(
          'fpath' => $tempstring.'/'.$form_values['fname'],
          'fname' => $form_values['fname'],
          'ftitle' => $form_values['ftitle'],
          'flang' => $form_values['flang'],
          'fstatus' => $form_values['fstatus'],
          'fclass' => $form_values['fclass'],
          'fdesc' => $form_values['fdesc'],
          'fkeywords' => $form_values['fkeywords'],
          'fdistribution' => $form_values['fdistribution'],
          'fraccess' => $form_values['fraccess'],
          'fwaccess' => $form_values['fwaccess'],
          'fchild' => $form_values['fchild'],
          'fnewver' => $form_values['fnewver'],
        );
        break;
      }  //end of the while loop
    } //end of code for a changed filename
    else {
      // ** filename hasn't changed **
      // load metadata variables ready for dbfm_update - added access data
      //even if the title hasn't changed a directory doesn't read the title into the form value array so..
      if ($orig_rec->fmime == 'directory') {
        if ($orig_rec->ftitle == '') {
          $form_values['ftitle'] = $orig_rec->fname;
        }
        else {
          $form_values['ftitle'] = $orig_rec->ftitle;
        }
      }
      $metadata=array(
        'ftitle' => $form_values['ftitle'],
        'flang' => $form_values['flang'],
        'fstatus' => $form_values['fstatus'],
        'fclass' => $form_values['fclass'],
        'fdesc' => $form_values['fdesc'],
        'fkeywords' => $form_values['fkeywords'],
        'fdistribution' => $form_values['fdistribution'],
        'fraccess' => $form_values['fraccess'],
        'fwaccess' => $form_values['fwaccess'],
        'fchild' => $form_values['fchild'],
        'fnewver' => $form_values['fnewver'],
      );
    } //end of code for no filename change - much easier!
  }

  // if there are no errors, then update the database
  if (!$updateerror) {
     // update the database
    if ($updateresult = dbfm_dbupdate_file($fid, $err, $metadata) == TRUE ) {
      $updatemessage = ('The changes were saved.');
      //if either the read or write setting are 'custom then call the add perms thingy
      $permchange = false;
      //DBFM_CUSTOM is defined in the dbfm.module
      if ($form_values['fraccess'] == DBFM_CUSTOM) {
        $perms_rresult = dbfm_add_perms('read', $fid,  $form_values);
        if ($perms_rresult) $permchange = true;
      }
      if ($form_values['fwaccess'] == DBFM_CUSTOM) {
        $perms_wresult = dbfm_add_perms('write', $fid,  $form_values);
        if ($perms_wresult) $permchange = true;
      }
      if ($permchange == true) {
        $updatemessage .= (' and the permissions were altered.');
      }
    }
    else {
      $updatemessage = 'Problems updating the database record for ' . $form_values['fname'];
      $updateerror = true;
    }
  } 

  //now - if the filename changed and this is a directory we need to do a recursive change to fix all the children
  if ($dirname_changed) {
    $err = '';  //used to collect any error message
    //re-read the file record
    $new_rec = dbfm_selected_file_record($fid,'', $err);
    dbfm_recur_dbrename($new_rec, $ret, $err);
    //I can't be bothered to check for errors!
  }
  //the problem with greybox always forcing a browser refresh is that we can end up losing the current file directory - use a session 
  //variable to keep it
  $_SESSION['fid'] = $orig_rec->fparent;
  
  //now I need a means of closing the greybox - being lazy I'll just let the user do it
  $updatemessage .= t('<br><br>You should now close this window.<br><br>');
  $page_output = dbfm_popconstructor2("dbFM Window", '', $updatemessage);
  print $page_output;

  exit;
  //note that the refresh for the tree and browser are currently in the greybox code. However whether or not the refresh happens
  //is dependant of the screen element 'refreshit'
}


/** 
 * Forms for file properties
 * Bear in mind that it's now 1:30 am and i cant actually see straight...
 * Don't expect me to apologise for sloppy code.
 * ZZZZZZZ At some point we need to move this into static data
 */
//need to know first whether they have write access to the file - if they do then make the attributes editable
//otherwise the form's read-only
function dbfm_form_properties() {
  global $gfrec;
  global $base_url;
  $err = '';  //used to return error strings

  // These will come from the DB later
  $languages[0] = 'English';
  $languages[1] = 'French';

  // These will come from the DB later - beware, this is also declared elsewhere!! Have to get it in the database soon
  $status[0] = 'Draft';
  $status[1] = 'Test';
  $status[2] = 'Approved';

  // So will these... we promise!
  $class[0] = 'Unclassified';
  $class[1] = 'Contract';
  $class[2] = 'Design';
  $class[3] = 'Guidelines';
  $class[4] = 'Organisation';
  $class[5] = 'Procedure';
  $class[6] = 'Product Marketing';
  $class[7] = 'Project Management';
  $class[8] = 'Quality Management';
  $class[9] = 'Specification';
  $class[10] = 'Template';
  $class[11] = 'Testing';
  $class[12] = 'User Documentation';

  // And these... ugh, i feel dirty. - son't you need things like restricted??
  $distribution[0] = 'Internal Only';
  $distribution[1] = 'Under Supervision';
  $distribution[2] = 'Public';

  //get the name of the file owner
  $qowner = "SELECT name FROM {users} WHERE uid = " . $gfrec->uid;
  $queryResult = db_query($qowner);
  $ownerrec = db_fetch_object($queryResult);

  //from the node table, fill in an array - $grouplist - of all possible organic groups
  //these are id / title pairs
  $groupsql = "SELECT nid, title FROM {node} WHERE type = '" . variable_get(dbfm_node_grp, "group") . "' ORDER BY title";
  $queryResult = db_query($groupsql);
  $numret = db_num_rows($queryResult);
  if ($numret == 0) {
    $nogroups = true;
  }
  else {
    $nogroups = false;
    while ($grouprecs = db_fetch_object($queryResult)) {
      $grouplist[$grouprecs->nid] = $grouprecs->title;
    }

    //from the file's permissions, fill in an array of all those groups already chosen for the selected item - read only
    //this is just an array of ints
    $grprolist = getpermarr($gfrec->fid, GROUP_RO);

    //from the file's permissions, fill in an array of all those groups already chosen for the selected item - read write
    //this is just an array of ints
    $grprwlist = getpermarr($gfrec->fid, GROUP_RW);
  }

  //from the role table, fill in an array - rolelist - of possible roles - should we do anything here about anonymous 
  //user and authenticated user? yes - we'll filter them out
  $rolesql = "SELECT rid, name FROM {role} WHERE rid > 2 ORDER BY name";
  $queryResult = db_query($rolesql);
  $numret = db_num_rows($queryResult);
  if ($numret == 0) {
    //set a flag so that the form control isn't drawn
    $noroles = true;
  }
  else {
    $noroles = false;
    while ($rolerecs = db_fetch_object($queryResult)) {
      $rolelist[$rolerecs->rid] = $rolerecs->name;
    }

    //from the file's permissions, fill in an array of roles already chosen for this item - read only
    //this is just an array of ints
    $rolrolist = getpermarr($gfrec->fid, ROLE_RO);

    //from the file's permissions, fill in an array of roles already chosen for this item - read write
    //this is just an array of ints
    $rolrwlist = getpermarr($gfrec->fid, ROLE_RW);
  }

  //NOW - to have got to here in the first place they needed to have read permissions for the file. We now
  //test whether they have write permissions in order to decide how to build the form
  $writeable = dbfm_check_perm($gfrec, READ_WRITE);

  //we also need to know whether these are properties for a directory of a file
  $objecttype = $gfrec->fmime;
  switch ($objecttype) {
    case 'directory':
      $object['ident'] = DBFM_DIRECTORY;
      $object['desc'] = 'Directory';
      break;
    case 'version':
      $object['ident'] = DBFM_VERSION;
      $object['desc'] = 'File';
      $revsql = "SELECT fid,  fversion, fstatus, fnewver FROM {dbfm_file} WHERE fparent = '".$gfrec->fid."'";
      $queryResult = db_query($revsql);
      while ($revsql = db_fetch_object($queryResult)) {
        $revlist[$revsql->fid] = ('Rev. '.$revsql->fversion);
        if ($revsql->fnewver != NULL) $revlist[$revsql->fid] .= (' - '.$revsql->fnewver);
        switch ($revsql->fstatus) {
          case 2:
            $revlist[$revsql->fid] .= (' (Approved)');
          break;
          case 1:
            $revlist[$revsql->fid] .= (' (Test)');
          break;
          default:
            $revlist[$revsql->fid] .= (' (Draft)');
          break;
        }
      }
    break;
    default:
      $object['ident'] = DBFM_OTHER;
      $object['desc'] = 'File';
    break;
  }

  //we need to keep the submit button somehow seperate from the tabs - and we don't have a submit button if the form's read 
  //only. NOTE: That the class divs span a number of controls
  $form = array();

  $content = $object['desc'].' '.t('properties: '.$gfrec->fid);

  $form['properties'] = array(
    '#type' => 'fieldset',
    '#title' => $content,
    '#collapsible' => FALSE,
    '#collapsed' => FALSE
  );

  $form['properties']['ptabs'] = array(
    '#type' => 'tabset',
  );

  $form['properties']['ptabs']['general'] = array(
    '#type' => 'tabpage',
    '#title' => t('General'),
  );

  $form['properties']['ptabs']['general']['fakefid'] = array(
    '#type'=> 'hidden',
    '#title' => $content,
    '#size' => '10',
    '#maxlength' => '10',
    '#value' => $gfrec->fid,
    '#prefix' => '<div class="formtop">',
  );

  $form['properties']['ptabs']['general']['fakepath'] = array(
    '#type'=> 'item',
    '#title' => t('Path'),
    '#value' => $gfrec->fpath,
    '#suffix' => '</div>',
 );

  $form['properties']['ptabs']['general']['fid'] = array(
    '#type'=> 'hidden',
    '#title' => $content,
    '#value' => $gfrec->fid,
  );

  $form['properties']['ptabs']['general']['fpath'] = array(
    '#type'=> 'hidden',
    '#title' => t('Path'),
    '#value' => $gfrec->fpath,
  );
  
  //now we need to know whether we've got a file or a directory and display contents accordingly

  //main form left class div starts here
  $content = $object['desc'].' '.t('name');

  if ($object['ident'] == DBFM_DIRECTORY) {
    if ($writeable) {
      $form['properties']['ptabs']['general']['fname'] = array(
        '#type'=> 'textfield',
        '#title' => $content,
        '#size' => '30',
        '#maxlength' => '255',
        '#default_value' => $gfrec->fname,
        '#prefix' => '<div class="formleft">',
        '#suffix' => '</div>',
      );
    }
    else {
      $form['properties']['ptabs']['general']['fname'] = array(
        '#type'=> 'item',
        '#title' => $content,
        '#value' => $gfrec->fname,
        '#prefix' => '<div class="formleft">',
        '#suffix' => '</div>',
      );
    }
  }
  else if ($object['ident'] == DBFM_VERSION) {
    $form['properties']['ptabs']['general']['fakefname'] = array(
      '#type'=> 'item',
      '#title' => $content,
      '#value' => $gfrec->fname,
      '#prefix' => '<div class="formleft">',
      '#suffix' => '</div>',
    );
    $form['properties']['ptabs']['general']['fname'] = array(
      '#type'=> 'hidden',
      '#title' => $content,
      '#value' => $gfrec->fname,
    );
  }
  else {
    if ($writeable) {
      //checking for a version id greater then 0 tells us that this is the child of a revision master
      if ($gfrec->fversion > 0) {
        $form['properties']['ptabs']['general']['fnewver'] = array(
          '#type'=> 'textfield',
          '#size' => '30',
          '#title' => t('File Version'),
          '#default_value' => $gfrec->fnewver,
          '#prefix' => '<div class="formleft">'
        );
        $form['properties']['ptabs']['general']['fname'] = array(
          '#type'=> 'textfield',
          '#title' => $content,
          '#size' => '30',
          '#maxlength' => '255',
          '#default_value' => $gfrec->fname
        );
      }
      else {
        $form['properties']['ptabs']['general']['fname'] = array(
          '#type'=> 'textfield',
          '#title' => $content,
          '#size' => '30',
          '#maxlength' => '255',
          '#default_value' => $gfrec->fname,
          '#prefix' => '<div class="formleft">'
        );
      }
    }
    else {
      $form['properties']['ptabs']['general']['fname'] = array(
        '#type'=> 'item',
        '#title' => $content,
        '#value' => $gfrec->fname,
        '#prefix' => '<div class="formleft">',
      );
    }

    if ($writeable) {
      $form['properties']['ptabs']['general']['ftitle'] = array(
        '#type'=> 'textfield',
        '#title' => t('File Title'),
        '#size' => '30',
        '#maxlength' => '255',
        '#default_value' => $gfrec->ftitle,
      );
    }
    else {
      $form['properties']['ptabs']['general']['ftitle'] = array(
        '#type'=> 'item',
        '#title' => t('File Title'),
        '#value' => $gfrec->ftitle,
      );
    }

    if ($writeable) {   
      $form['properties']['ptabs']['general']['flang'] = array(
        '#type' => 'select', 
        '#title' => t('Language'), 
        '#default_value' => $gfrec->flang,
        '#options' => $languages,
      );
    }
    else {
      //we have to find the text value associated with the integer held in flang
      $lval = $languages[$gfrec->flang];
      $form['properties']['ptabs']['general']['flang'] = array(
        '#type' => 'item',
        '#title' => t('Language'),
        '#value' => $lval,
      );
    }

    if ($writeable) {
      $form['properties']['ptabs']['general']['fstatus'] = array(
        '#type' => 'select', 
        '#title' => t('Status'), 
        '#default_value' => $gfrec->fstatus,
        '#options' => $status,
      );
    }
    else {
      $sval = $status[$gfrec->fstatus];
      $form['properties']['ptabs']['general']['fstatus'] = array(
        '#type' => 'item',
        '#title' => t('Status'),
        '#value' => $sval,
      );
    }

    if ($writeable) {
      $form['properties']['ptabs']['general']['fdistribution'] = array(
        '#type' => 'select',
        '#title' => t('Distribution'),
        '#default_value' => $gfrec->fdistribution,
        '#options' => $distribution
      );
    }
    else {
      $dval = $distribution[$gfrec->fdistribution];
      $form['properties']['ptabs']['general']['fdistribution'] = array(
        '#type' => 'item',
        '#title' => t('Distribution'),
        '#value' => $dval,
      );
    }

    if ($writeable) {
      $form['properties']['ptabs']['general']['fclass'] = array(
        '#type' => 'select', 
        '#title' => t('Class'),
        '#default_value' => $gfrec->fclass,
        '#options' => $class,
        '#suffix' => '</div>',
      );
    }
    else {
      $pval = $class[$gfrec->fclass];
      $form['properties']['ptabs']['general']['fclass'] = array(
        '#type' => 'item',
        '#title' => t('Class'),
        '#value' => $pval,
        '#suffix' => '</div>',
      );
    }
  }

  switch ($object['ident']) {
    case DBFM_DIRECTORY:
      $content = t('Files/Directories');
    break;
    case DBFM_VERSION:
      $content = t('Files');
    break;
    default:
      $content = t('Size');
    break;
  }

  //start of form left class div - these fields are already read-only
  $form['properties']['ptabs']['general']['fsize'] = array(
    '#type'=> 'item',
    '#title' => $content,
    '#value' => $gfrec->fsize,
    '#prefix' => ('<div class="formright">')
  );

  $form['properties']['ptabs']['general']['flastmod'] = array(
    '#type'=> 'item',
    '#title' => t('Modified'),
    '#value' => $gfrec->flastmod
  );

  $form['properties']['ptabs']['general']['fcreatedate'] = array(
    '#type'=> 'item',
    '#title' => t('Created'),
    '#value' => $gfrec->fcreatedate
  );

  $form['properties']['ptabs']['general']['ownerinfo'] = array(
    '#type'=> 'item',
    '#title' => t('Owner'),
    '#value' => $ownerrec->name,
  );

  $form['properties']['ptabs']['general']['fmime'] = array(
    '#type'=> 'item',
    '#title' => t('Type'),
    '#value' => $gfrec->fmime
  );

  if (stristr($gfrec->fmime, 'image')){
    $form['properties']['ptabs']['general']['fimagesize'] = array(
      '#type'=> 'item',
      '#title' => t('Dimensions'),
      '#value' => $gfrec->fimagesize,
      '#suffix' => ('<img src="'.$base_url.'/dbfm_send/'.$gfid .'">')
    );
  }
  //number of downloads - this needs to be modified such that it better relects the true number of accesses ZZZZZZZZZZZ
  if ($object['ident'] > DBFM_VERSION) {
    $form['properties']['ptabs']['general']['fdown'] = array(
      '#type'=> 'item',
      '#title' => t('Views'),
      '#value' => $gfrec->fdown,
    );
  }

  //^^ end of the form right div
  if ($object['ident'] > DBFM_DIRECTORY) {
    $form['properties']['ptabs']['general']['fdesc'] = array(
      '#type'=> 'textarea',
      '#title' => t('Notes'),
      '#size' => '30',
      '#rows' => '2',
      '#default_value' => $gfrec->fdesc,
      '#disabled' => !$writeable,
      '#prefix' => '</div><div class="formbottom">',
    );
//
    if ($object['ident'] == DBFM_VERSION) {
      if ($writeable) {
        $form['properties']['ptabs']['general']['fchild'] = array(
          '#type' => 'select', 
          '#title' => t('Current Revision'), 
          '#default_value' => $gfrec->fchild,
          '#options' => $revlist,
        );
      }
      else {
        //we have to find the text value associated with the integer held in flang
        $fchildver = ('Rev. '.$gfrec->fversion);
        if ($gfrec->fnewver != NULL) $fdownver .= (' - '.$gfrec->fnewver);
        switch ($gfrec->fstatus) {
          case 2:
            $fchildver .= (' (Approved)');
          break;
          case 1:
            $fchildver .= (' (Test)');
          break;
          default:
            $fchildver .= (' (Draft)');
          break;
        }

        $form['properties']['ptabs']['general']['fchild'] = array(
          '#type' => 'item',
          '#title' => t('Current Revision'),
          '#value' => $fchildver,
        );
      }
    }
//
    $form['properties']['ptabs']['general']['fkeywords'] = array(
      '#type'=> 'textarea',
      '#title' => t('Keywords'),
      '#size' => '30',
      '#rows' => '1',
      '#default_value' => $gfrec->fkeywords,
      '#disabled' => !$writeable,
      '#suffix' => '</div>'
    );
  }
  else {
    $form['properties']['ptabs']['general']['fdesc'] = array(
      '#type'=> 'textarea',
      '#title' => t('Notes'),
      '#size' => '30',
      '#rows' => '3',
      '#default_value' => $gfrec->fdesc,
      '#disabled' => !$writeable,
      '#prefix' => '</div><div class="formbottom">',
      '#suffix' => '</div>'
    );
  }

  // ZZZ content for the access form, need to differentiate between files and directories
  $content = $object['desc'].' '.t('Permissions');

  $form['properties']['ptabs']['accessrw'] = array(
    '#type' => 'tabpage',
    '#title' => t('Read/Write Access'),
  );

  //radio set to allow them to chose between private, public and custom Need some mechanism (in java?) to grey out the role/group
  //boxes unless custom is selected. By default files will inherit permissions from their parent directory ZZZ we need the code (when we create a new file) to fill in these details into the access table
  $form['properties']['ptabs']['accessrw']['fwaccess'] = array(
    '#type' => 'radios',
    '#title' => t('Access Type'),
    '#default_value' => $gfrec->fwaccess,
    '#disabled' => !$writeable,
    '#prefix' => '<div id="radiorw">',
    '#suffix' => '</div>',

    '#options' => array(DBFM_PRIVATE => t('Private, only writeable by the owner (or an administrator)'),
      DBFM_PUBLIC => t('Public, writable by all users.'),
      DBFM_CUSTOM => t('Restricted, writeable by the file owner (and the roles and groups detailed below - optional)')),
  );
  
  if ($noroles == false) {
    $form['properties']['ptabs']['accessrw']['roletxt'] = array(
      '#type'=> 'item',
      '#title' => t('Roles'),
      '#prefix' => ('<div class="aclrole" id="rwaclrole"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['ptabs']['accessrw']['wrole'] = array(
     '#type' => 'select',
     '#options' => $rolelist,
     '#multiple' => true,
     '#disabled' => !$writeable,
     '#default_value' => $rolrwlist,
     '#size' => 7,       //number of lines in the select box
     '#description' => t('Select the roles whose users should have read/write access to this file/directory'),
     '#suffix' => ('</div>')
    );
  }
  if ($nogroups == false) {
    $form['properties']['ptabs']['accessrw']['grouptxt'] = array(
      '#type'=> 'item',
      '#title' => t('Workgroups'),
      '#prefix' => ('<div class="aclgroup" id="rwaclgroup"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['ptabs']['accessrw']['wgroup'] = array(
     '#type' => 'select',
     '#options' => $grouplist,
     '#multiple' => true,
     '#disabled' => !$writeable,
     '#default_value' => $grprwlist,
     '#size' => 7,    //number of lines in the select box
     '#description' => t('Select the groups whose users should have read/write access to this file/directory'),
     '#suffix' => ('</div>')
    );
  }
  if ($nogroups == false AND $noroles == false) {
    $form['properties']['ptabs']['accessrw']['instruct'] = array(
      '#type'=> 'item',
      '#value' => t('Note that it is NOT necessary to add roles and groups to the read access lists if they appear on the read/write lists'),
    );
  }

  // ZZZ content for the access form, need to differentiate between files and directories
  $content = $object['desc'].' '.t('Permissions');

  $form['properties']['ptabs']['accessro'] = array(
    '#type' => 'tabpage',
    '#title' => t('Read Access'),
  );

  //radio set to allow them to chose between private, public and custom Need some mechanism (in java?) to grey out the role/group
  //boxes unless custom is selected. By default files will inherit permissions from their parent directory ZZZ we need the code (when we create a new file) to fill in these details into the access table
  $form['properties']['ptabs']['accessro']['fraccess'] = array(
    '#type' => 'radios',
    '#title' => t('Access Type'),
    '#default_value' => $gfrec->fraccess,
    '#disabled' => !$writeable,
    '#prefix' => '<div id="radioro">',
    '#suffix' => '</div>',

    '#options' => array(DBFM_PRIVATE => t('Private, only accessible by the owner (or an administrator)'), 
      DBFM_PUBLIC => t('Public, accessable by all users.'), 
      DBFM_CUSTOM => t('Restricted, accessable by the file owner (and the roles and groups detailed below - optional)')), 
  );

  if ($noroles == false) { 
    $form['properties']['ptabs']['accessro']['roletxt'] = array(
      '#type'=> 'item',
      '#title' => t('Roles'),
      '#prefix' => ('<div class="aclrole" id="roaclrole"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['ptabs']['accessro']['rrole'] = array(
     '#type' => 'select',
     '#default_value' => $rolrolist,
     '#options' => $rolelist,
     '#disabled' => !$writeable,
     '#multiple' => true,
     '#size' => 7,
     '#description' => t('Select the roles whose users should have read access to this file/directory'),
     '#suffix' => ('</div>')
    );
  }
  if ($nogroups == false) {
    $form['properties']['ptabs']['accessro']['grouptxt'] = array(
      '#type'=> 'item',
      '#title' => t('Workgroups'),
      '#prefix' => ('<div class="aclgroup" id="roaclgroup"><div class="txtlbl">'),
      '#suffix' => ('</div>')
    );

    $form['properties']['ptabs']['accessro']['rgroup'] = array(
     '#type' => 'select',
     '#default_value' => $grprolist,
     '#options' => $grouplist,
     '#disabled' => !$writeable,
     '#multiple' => true,
     '#size' => 7,
     '#description' => t('Select the groups whose users should have read access to this file/Directory'),
     '#suffix' => ('</div>')
    );
  }

  $form['properties']['ptabs']['accessro']['endpart'] = array(
    '#type' => 'item'
  );

  if ($writeable) {
    // the floating submit button for all tabs
    $form['properties']['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Save changes'),
      '#prefix' => '<div class="formcontrols">',
      '#suffix' => '</div>'
    );
  }

  return $form;
  
//note that the submit code must make sure the path is changed if the filename is changed
//directories will NOT allow a change of name here. It would involve recursive code changing the paths
//of every child. The code already exists as a context menu option and I can't see the need to link to it here.  
}
